

#if defined(OS_WIN32)
#include <windows.h>
#include <malloc.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <exception>
#include <math.h>
#include <string.h>

#include "BVQXPluginInterface.h"
#include "Plugin_SRF_Header.h"
#include "colortools.h"


bool changeMeshColorRGB(SRF_Header *srfqx) {
  
		int cntr, border, nrvertices;
		nrvertices = srfqx->NrOfVertices;
		border = int(floorf(nrvertices/5));
		int *newcolors = new int[nrvertices];
		char *colortxt = new char[256];
		sprintf(colortxt, "Number of vertices: %d", nrvertices);
		qxLogText(colortxt);
		sprintf(colortxt, "Current convex components: R: %f, G: %f, B: %f", 
			srfqx->Base1ColorR, srfqx->Base1ColorG, srfqx->Base1ColorB);
		qxLogText(colortxt);
		sprintf(colortxt, "Current concave components: R: %f, G: %f, B: %f", 
			srfqx->Base2ColorR, srfqx->Base2ColorG, srfqx->Base2ColorB);
		qxLogText(colortxt);

		char *logtxt = new char[256];
		sprintf(logtxt, "Please specify the range of vertices that should get a new color (number of vertices: %d)...", nrvertices);
		qxMessageBox(logtxt);

		int minval = 0;
		int defaultval = 0;
					
		char instrRangeMin[] = "Please enter the first vertex number of the range";
		int maxvert = srfqx->NrOfVertices;
		int minRange = qxGetIntegerInput(instrRangeMin, defaultval, minval, maxvert);
		char instrRangeMax[] = "Please enter the last vertex number of the range (inclusive)";
		int maxRange = qxGetIntegerInput(instrRangeMax, defaultval, minval, maxvert);									

			int min = 0;
			int max = 2000000000;
			
			int startval = 1056964608;
			int def = startval;
			
			int rgb = hexToDec();

			for (cntr = minRange; cntr < (maxRange + 1); cntr++) {
				srfqx->VertexColor[cntr] = startval + rgb;
			}
				
			qxUpdateActiveWindow();
				
			int save = qxYesNoMessageBox("Would you like to save the changes in a SRF file?");
			if (save) {
				char *newname = new char[256];
				char *bvpath = new char[256];
				qxGetBrainVoyagerQXPath(bvpath);
				int response = qxGetSaveFileName("Please enter the new SRF file name", bvpath, "Surface files (*.srf)", newname);
				if (response > 0) {
					qxSaveCurrentSRF(newname);
				}
			}
		
		return true;
}

void printColorsOfRangeToLogtab(SRF_Header *srfqx) {

	int minval = 0;
	int defaultval = 0;
	char instrRangeMin[] = "Please enter the first vertex number of the range";
	int maxvert = srfqx->NrOfVertices;
	int minRange = qxGetIntegerInput(instrRangeMin, defaultval, minval, maxvert);
	char instrRangeMax[] = "Please enter the last vertex number of the range (inclusive)";
	int maxRange = qxGetIntegerInput(instrRangeMax, defaultval, minval, maxvert);
	char *logtxt = new char[256];
	int cntr;
	for (cntr = minRange; cntr < (maxRange + 1); cntr++) {
		sprintf(logtxt, "Vertex: %d, value: %d", cntr, srfqx->VertexColor[cntr]);
		qxLogText(logtxt);
	}
}

int hexToDec() {

	int decimalValue;
	char *logtxt = new char[256];
	char instrHex[] = "Please enter the color in hexadecimals (without 0x)";
	char defaultTxt[] = "FFFFFF";
	char *hexText = new char[256];
	int response = qxGetTextInput(instrHex, defaultTxt, hexText);
	if (response > 0) {
		
		sprintf(logtxt, "The color entered in hexadecimal format is: %s", hexText);
		qxLogText(logtxt);
		
		decimalValue = hexToDec(hexText);
		
		sprintf(logtxt, "The corresponding decimal value is: %d", decimalValue);
		qxLogText(logtxt);
	}
	return decimalValue;
}

int hexToDec(char *hexstring) {

	int counter;
	int dec = 0;
	char ch;
	int len = strlen(hexstring)-1;
	for (counter = 0; counter <= len; counter++) {

		ch = hexstring[len - counter];

		switch (ch) {

			case 'F': 
				dec += (((counter == 0) ? 15: 
				(counter == 1) ? 15 * 16:
				15 * powf(16, counter))); 
				break;
			case 'E': 
				dec += (((counter == 0) ? 14: 
				(counter == 1) ? 14 * 16:
				14 * powf(16, counter))); 
				break;
			case 'D': 
				dec += (((counter == 0) ? 13: 
				(counter == 1) ? 13 * 16:
				13 * powf(16, counter)));  
				break;
			case 'C': 
				dec += (((counter == 0) ? 12: 
				(counter == 1) ? 12 * 16 :
				12 * powf(16, counter))); 
				break;
			case 'B': 
				dec += (((counter == 0) ? 11: 
				(counter == 1) ? 11 * 16:
				11 * powf(16, counter))); 
				break;
			case 'A': 
				dec += (((counter == 0) ? 10: 
				(counter == 1) ? 10 * 16:
				10 * powf(16, counter))); 
				break;
			case '9':  
				dec += (((counter == 0) ? 9: 
				(counter == 1) ? 9 * 16 :
				9 * powf(16, counter))); 
				break;
			case '8': 
				dec += (((counter == 0) ? 8: 
				(counter == 1) ? 8 * 16 :
				8 * powf(16, counter))); 
				break;
			case '7': dec += (((counter == 0) ? 7: 
				(counter == 1) ? 7 * 16:
				7 * powf(16, counter)));  
				break;
			case '6': dec += (((counter == 0) ? 6: 
				(counter == 1) ? 6 * 16:
				6 * powf(16, counter))); 
				break;
			case '5': dec += (((counter == 0) ? 5: 
				(counter == 1) ? 5 * 16:
				5 * powf(16, counter))); 
				break;
			case '4': dec += (((counter == 0) ? 4: 
				(counter == 1) ? 4 * 16:
				4 * powf(16, counter))); 
				break;
			case '3': dec += (((counter == 0) ? 3: 
				(counter == 1) ? 3 * 16:
				3 * powf(16, counter))); 
				break;
			case '2': dec += (((counter == 0) ? 2: 
				(counter == 1) ? 2 * 16:
				2 * powf(16, counter))); 
				break;
			case '1': dec += (((counter == 0) ? 1: 
				(counter == 1) ? 1 * 16:
				1 * powf(16, counter))); 
				break;
			case '0': dec += (((counter == 0) ? 0: 
				(counter == 1) ? 0 * 16 :
				0 * powf(16, counter))); 
				break;		
		}
	}

	return dec;
}

char *decToHex(int combinedcolor, int RGB){

	char *tmpstr = new char[20];	   
	sprintf(tmpstr, "%x", combinedcolor);	
//	char *hexstr = new char[strlen(tmpstr)];
	char *hexstr = new char[2];
	if (RGB == 1) {
		sprintf(hexstr, "%c", tmpstr[0]);
		sprintf(hexstr +strlen(hexstr), "%c", tmpstr[1]);
	}
	if (RGB == 2) {
		sprintf(hexstr, "%c", tmpstr[2]);
		sprintf(hexstr +strlen(hexstr), "%c", tmpstr[3]);
	}
	if (RGB == 3) {
		sprintf(hexstr, "%c", tmpstr[4]);
		sprintf(hexstr +strlen(hexstr), "%c", tmpstr[5]);
	}
	
//	sprintf(hexstr, "%s", tmpstr);
	return hexstr;
}

int getAutoColor(int index, bool is5x2) {

        if (is5x2) {
        switch (index) {
                case 0: return hexToDec("333300"); // announceRound
                case 1: return hexToDec("993300");
                case 2: return hexToDec("FF3399");
                case 3: return hexToDec("0000FF");
                case 4: return hexToDec("CCCCCC");
                case 5: return hexToDec("990066"); // feedbackExp1
                case 6: return hexToDec("660000"); // feedbackExp2_ext_neg
                case 7: return hexToDec("FF0000"); // neg
                case 8: return hexToDec("FF9900"); // zero
                case 9: return hexToDec("FFFF99"); // pos
                case 10: return hexToDec("FFFF00"); // ext_pos
                case 11: return hexToDec("CCCCCC"); // fixation2
                case 12: return hexToDec("00FF00");
                case 13: return hexToDec("CCCCCC"); // fixation3
                case 14: return hexToDec("009900");
                case 15: return hexToDec("CCCCCC"); // fixation4
                case 16: return hexToDec("3366CC");
                case 17: return hexToDec("999933"); // fixationWithCross
                default: return hexToDec("000000");
                        break;
                }
        } else {

                switch (index) {

                        case 0: return hexToDec("333300"); // announceRound
                        case 1: return hexToDec("993300");
                        case 2: return hexToDec("FF3399");
                        case 3: return hexToDec("0000FF");
                        case 4: return hexToDec("CCCCCC");
                        case 5: return hexToDec("990066"); // feedbackExp1
                        case 6: return hexToDec("660000");	// feedbackExp2
                        case 7: return hexToDec("CCCCCC"); // fixation2
                        case 8: return hexToDec("00FF00");
                        case 9: return hexToDec("CCCCCC"); // fixation3
                        case 10: return hexToDec("009900"); // feedbackDecision
                        case 11: return hexToDec("CCCCCC"); // fixation4
                        case 12: return hexToDec("3366CC"); // feedbackEarnings
                        case 13: return hexToDec("999933"); // fixationWithCross
                        default: return hexToDec("000000");
                        break;
                }
        }
}

int getMultiAutoColor(int index, int typeOfAnalysis) {

     if (typeOfAnalysis == ANALYSIS_GLM) {
           switch (index) {

                case 0: return hexToDec("333300"); // announceRound
                case 1: return hexToDec("993300");
                case 2: return hexToDec("FF3399");
                case 3: return hexToDec("0000FF");
                case 4: return hexToDec("CCCCCC");
                case 5: return hexToDec("990066"); // feedbackExp1
                case 6: return hexToDec("660000");	// feedbackExp2
                case 7: return hexToDec("CCCCCC"); // fixation2
                case 8: return hexToDec("00FF00"); // expressDecision
                case 9: return hexToDec("CCCCCC"); // fixation3
                case 10: return hexToDec("009900"); // feedbackDecision
                case 11: return hexToDec("CCCCCC"); // fixation4
                case 12: return hexToDec("3366CC");
                case 13: return hexToDec("999933"); // fixationWithCross
                default: return hexToDec("000000");
                break;
            }
        } else if (typeOfAnalysis == ANALYSIS_GLM_5X2) {

            switch (index) {
                case 0: return hexToDec("333300"); // 1. announceRound
                case 1: return hexToDec("993300"); // 2. playerType1
                case 2: return hexToDec("FF3399"); // 3. playerType0
                case 3: return hexToDec("0000FF"); // 4. expressExp
                case 4: return hexToDec("CCCCCC"); // 5. fixation1
                case 5: return hexToDec("990066"); // 6. feedbackExp1
                case 6: return hexToDec("660000"); // 7. feedbackExp2_ext_neg
                case 7: return hexToDec("FF0000"); // 8. feedbackExp2_neg
                case 8: return hexToDec("FF9900"); // 9. feedbackExp2_zero
                case 9: return hexToDec("FFFF99"); // 10. feedbackExp2_pos
                case 10: return hexToDec("FFFF00"); // 11. feedbackExp2_ext_pos
                case 11: return hexToDec("CCCCCC"); // 12. fixation2
                case 12: return hexToDec("00FF00"); // 13. expressDecision
                case 13: return hexToDec("CCCCCC"); // 14. fixation3
                case 14: return hexToDec("009900"); // 15. feedbackDecision
                case 15: return hexToDec("CCCCCC"); // 16. fixation4
                case 16: return hexToDec("3366CC"); // 17. feedbackEarnings
                case 17: return hexToDec("999933"); // 18. fixationWithCross
                default: return hexToDec("000000");
                        break;
                }

        } else if (typeOfAnalysis == ANALYSIS_GLM_MATCH_EARNINGS) {

              switch (index) {
                case 0: return hexToDec("333300"); // 1. announceRound
                case 1: return hexToDec("993300"); // 2. playerType1
                case 2: return hexToDec("FF3399"); // 3. playerType0
                case 3: return hexToDec("0000FF"); // 4. expressExp
                case 4: return hexToDec("CCCCCC"); // 5. fixation
                case 5: return hexToDec("990066"); // 6. feedbackExp1
                case 6: return hexToDec("660000"); // 7. feedbackExp2
                case 7: return hexToDec("CCCCCC"); // 8. fixation2
                case 8: return hexToDec("FF9900"); // 9. expressDecision
                case 9: return hexToDec("CCCCCC"); // 10. fixation3
                case 10: return hexToDec("009900"); // 11. feedbackDecision
                case 11: return hexToDec("CCCCCC"); // 12. fixation4
                case 12: return hexToDec("6600FF"); // 13. feedbackEarnings_A_larger_B (purple)
                case 13: return hexToDec("9900FF"); // 14. feedbackEarnings_A_equal_B (purple)
                case 14: return hexToDec("CC00FF");  // 15. feedbackEarnings_A_smaller_B (purple)
                case 15: return hexToDec("999933"); // 16. fixationWithCross
                default: return hexToDec("000000");
                        break;
             }
			
		} else if (typeOfAnalysis == ANALYSIS_GLM_OFFERA_PLAYERTYPE) { // 23 predictors
				
				switch (index) {
					case 0: return hexToDec("333300"); // 1. announceRound
					case 1: return hexToDec("993300"); // 2. playerType1
					case 2: return hexToDec("FF3399"); // 3. playerType0
					case 3: return hexToDec("0000FF"); // 4. expressExp
					case 4: return hexToDec("CCCCCC"); // 5. fixation1
					case 5: return hexToDec("990066"); // 6. feedbackExp1
					case 6: return hexToDec("660000"); // 7. feedbackExp2_ext_neg_human
					case 7: return hexToDec("FF0000"); // 8. feedbackExp2_neg_human
					case 8: return hexToDec("FF9900"); // 9. feedbackExp2_zero_human
					case 9: return hexToDec("FFFF99"); // 10. feedbackExp2_pos_human
					case 10: return hexToDec("FFFF00"); // 11. feedbackExp2_ext_pos_human
					case 11: return hexToDec("0099FF"); // 12. feedbackExp2_ext_neg_pc
					case 12: return hexToDec("33CCFF"); // 13. feedbackExp2_neg_pc
					case 13: return hexToDec("FFCCFF"); // 14. feedbackExp2_zero_pc
					case 14: return hexToDec("CC00FF"); // 15. feedbackExp2_pos_pc
					case 15: return hexToDec("9900FF"); // 16. feedbackExp2_ext_pos_pc						
					case 16: return hexToDec("CCCCCC"); // 17. fixation2
					case 17: return hexToDec("00FF00"); // 18. expressDecision
					case 18: return hexToDec("CCCCCC"); // 19. fixation3
					case 19: return hexToDec("009900"); // 20. feedbackDecision
					case 20: return hexToDec("CCCCCC"); // 21. fixation4
					case 21: return hexToDec("3366CC"); // 22. feedbackEarnings
					case 22: return hexToDec("999933"); // 23. fixationWithCross
					default: return hexToDec("000000");
                        break;
                }

		} else if (typeOfAnalysis == ANALYSIS_GLM_MATCH_EXP_PLAYERTYPE) { // 20 pred.
			
			switch (index) {
				case 0: return hexToDec("333300");  // 1. announceRound
				case 1: return hexToDec("993300");  // 2. playerType1
				case 2: return hexToDec("FF3399");  // 3. playerType0
				case 3: return hexToDec("0000FF"); // 4. expressExp
				case 4: return hexToDec("CCCCCC"); // 5. fixation1
				case 5: return hexToDec("990066"); // 6. feedbackExp1
				case 6: return hexToDec("660000"); // 7. feedbackExp2_A_larger_B_human
				case 7: return hexToDec("FF9900"); // 8. feedbackExp2_A_equal_B_human
				case 8: return hexToDec("FFFF00"); // 9. feedbackExp2_A_smaller_B_human
				case 9: return hexToDec("0099FF");  // 10. feedbackExp2_A_larger_B_pc
				case 10: return hexToDec("FFCCFF");  // 11. feedbackExp2_A_equal_B_pc
				case 11: return hexToDec("9900FF"); // 12. feedbackExp2_A_smaller_B_pc					
				case 12: return hexToDec("CCCCCC"); // 13. fixation2
				case 13: return hexToDec("00FF00"); // 14. expressDecision
				case 14: return hexToDec("CCCCCC"); // 15. fixation3
				case 15: return hexToDec("009900"); // 16. feedbackDecision
				case 16: return hexToDec("CCCCCC"); // 17. fixation4
				case 17: return hexToDec("3366CC"); // 18. feedbackEarnings
				case 18: return hexToDec("999933"); // 19. fixationWithCross
				default: return hexToDec("000000");
					break;
			}
			
		} else if (typeOfAnalysis == ANALYSIS_GLM_MATCH_EARNINGS_PLAYERTYPE) { // 20 pred.
			
			switch (index) {
				case 0: return hexToDec("333300");  // 1. announceRound
				case 1: return hexToDec("993300");  // 2. playerType1
				case 2: return hexToDec("FF3399");  // 3. playerType0
				case 3: return hexToDec("0000FF"); // 4. expressExp
				case 4: return hexToDec("CCCCCC"); // 5. fixation1
				case 5: return hexToDec("990066"); // 6. feedbackExp1
				case 6: return hexToDec("3366CC"); // 7. feedbackExp2
				case 7: return hexToDec("CCCCCC"); // 8. fixation2
				case 8: return hexToDec("00FF00"); // 9. expressDecision
				case 9: return hexToDec("CCCCCC"); // 10. fixation3
				case 10: return hexToDec("009900"); // 11. feedbackDecision
				case 11: return hexToDec("CCCCCC"); // 12. fixation4
				case 12: return hexToDec("660000"); // 13. feedbackEarnings_A_larger_B_human
				case 13: return hexToDec("FF9900"); // 14. feedbackEarnings_A_equal_B_human
				case 14: return hexToDec("FFFF00"); // 15. feedbackEarnings_A_smaller_B_human
				case 15: return hexToDec("0099FF");  // 16. feedbackEarnings_A_larger_B_pc
				case 16: return hexToDec("FFCCFF");  // 17. feedbackEarnings_A_equal_B_pc
				case 17: return hexToDec("9900FF"); // 18. feedbackEarnings_A_smaller_B_pc	
				case 19: return hexToDec("999933"); // 19. fixationWithCross
				default: return hexToDec("000000");
					break;
			}
		} else if (typeOfAnalysis == ANALYSIS_GLM_EXPEXP_HPC) { // 15 pred.
			
			switch (index) {
				case 0: return hexToDec("333300");  // 1. announceRound
				case 1: return hexToDec("993300");  // 2. playerType1
				case 2: return hexToDec("FF3399");  // 3. playerType0
				case 3: return hexToDec("CC6600"); // 4. Expectation_h
				case 4: return hexToDec("CC6666"); // 5. Expectation_pc	
				case 5: return hexToDec("CCCCCC"); // 6. fixation1
				case 6: return hexToDec("990066"); // 7. feedbackExp1
				case 7: return hexToDec("3366CC"); // 8. feedbackExp2
				case 8: return hexToDec("CCCCCC"); // 9. fixation2
				case 9: return hexToDec("00FF00"); // 10. expressDecision
				case 10: return hexToDec("CCCCCC"); // 11. fixation3
				case 11: return hexToDec("009900"); // 12. feedbackDecision
				case 12: return hexToDec("CCCCCC"); // 13. fixation4
				case 13: return hexToDec("660000"); // 14. feedbackEarnings
				case 14: return hexToDec("999933"); // 15. fixationWithCross
				default: return hexToDec("000000");
					break;
			}	

        }  else {
            return hexToDec("000000");
        }
}
