#if defined(OS_WIN32)
#include <windows.h>
#include <malloc.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <math.h>
#include <string>
#include "BVQXPluginInterface.h"
#include "iofuncs.h"
#include <string.h>

// get basename
char *getFileName(char *fullFileName, bool basename, bool forSTC){

	int i,ii;
	int endpos = 0; int strLength; 
	if( fullFileName == NULL || (strLength=strlen(fullFileName)) == 0){  
		return NULL;
	}
	char pathSign; 
	bool fw = false;
	for (i=0; i<strLength; i++) {
		fw = (fullFileName[i]=='/');
		if (fw) break;
	}
	if (fw) {
		pathSign = '/';
	} else {
		pathSign = '\\';
	}

	int endIndex = 0;
	for( ii=strLength; ii > 0; ii-- ){
		if (fullFileName[ii] == pathSign) {
			endIndex = ii + 1;
			break;
		} 
		if (fullFileName[ii] == '.') {
			endpos = (endpos > 0 ? endpos : ii); 
			//   endpos = (endpos > 0 ? endpos : (forSTC ? ii-3 : ii)); 
		}
	}

	if (!basename) {
		endpos = strLength;
	}

	int newlen = (forSTC ? (strLength - endIndex + 2): (strLength - endIndex + 1));
	char *outName = new char[newlen];
	sprintf(outName, "%c", fullFileName[endIndex]);   
	for (ii = endIndex+1; ii < endpos; ii++) {
		sprintf(outName+strlen(outName), "%c", fullFileName[ii]);
	}

	if (forSTC) sprintf(outName+strlen(outName), "%c", '-'); 
	sprintf(outName+strlen(outName), "%c", '\0');   
	return outName;
}

char *getFileExtension(char *fileName) {

	int strLength; int counter;
	int extLength = 4;
	char *fileExt;
	strLength=strlen(fileName);
	if( fileName == NULL || (strLength) == 0){  
		qxLogText("Small problem extracting file extension");
		return "-1";
	}
	int endIndex = 0;
	fileExt = (char *)calloc(1, (extLength+1));    
	for(counter=0; counter < extLength; counter++){
		fileExt[counter] = fileName[strLength-extLength+counter];
	}
	return fileExt;
}

// The removeExtension function returns the filename without its extension, f.e. to 
//create a filename with another extension from it 
char *removeExtension(char *fileName){
	int ii; int strLength; int lout;
	char *outName ;
	if( fileName == NULL || (strLength=strlen(fileName)) == 0){  
		outName = strdup("''") ; return outName;
	}
	int endIndex = 0;
	lout = 4 ;                    
	for( ii=0 ; ii < strLength ; ii++ ){ 
		switch( fileName[ii] ){
		case '.': endIndex = ii;		
		default: lout++ ; break ;   

		}
	}
	outName = (char *)calloc(1,lout) ;    
	for( ii=0; ii < endIndex; ii++){
		outName[ii] = fileName[ii];
	}
	outName[ii]   = '\0' ;  
	return outName;

}

char *createFileName(char *fileName, char *inter){

	char *dataTypeStr = NULL;
	int newLen = strlen(fileName) + strlen(inter) + 1;
	char *fileType = getFileExtension(fileName);
	char ending = '\0';
	char *result = new char[newLen];
	sprintf(result, "%s%s%s%c", removeExtension(fileName), inter, fileType, ending);
	return result;
}



char *exchangeExtension(char *currentFileName, char *newExtension) {

	int length;
	char *result;
	char *fileNameWithoutExt = removeExtension(currentFileName);
	length = strlen(fileNameWithoutExt);
	int extLength = strlen(newExtension);
	result = new char[length+extLength];
	strcpy(result, fileNameWithoutExt);
	strcat(result, newExtension);
	return result;

}
